<?php

namespace App\Http\Controllers;

use App\Http\Resources\PermissionResource;
use App\Http\Requests\UsersRequest;
use App\Http\Resources\UserResource;
use App\Laravue\JsonResponse;
use App\Laravue\Models\Device;
use App\Laravue\Models\Users;
use App\Laravue\Models\Homepage;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\ResourceCollection;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Redis;
use Validator;

class UinappHomeController extends Controller
{
    public function devicedatainfo($id)
    {
        $data = DB::table('device as d')
            ->join('device_type as t', 'd.dtype', '=', 't.tid')
            ->join('gas as g', 'd.status', '=', 'g.id')
            ->join('danwei as  w', 'd.devicemonad', '=', 'w.id')
            ->join('status as s', 'd.devicepolice', '=', 's.id')
            ->join('users as u', 'd.uid', '=', 'u.id')
            ->where('d.id', '=', $id)
            ->select('d.*', 't.tname', 'g.gas', 'w.danwei', 's.status_name', 'u.username as nameh', 'u.isadmin')
            ->first();
        return $this->jsonSuccessData($data);
    }

    //获取模糊查询设备
    public function imitation(Request $request)
    {
        $imitationdata = $request->input('imitationdata');

        if ($imitationdata != '') {
            if ($this->isKanji($imitationdata)) {
                $data = DB::table('device as d')
                    ->join('device_type as t', 'd.dtype', '=', 't.tid')
                    ->join('gas as g', 'd.status', '=', 'g.id')
                    ->join('danwei as  w', 'd.devicemonad', '=', 'w.id')
                    ->join('status as s', 'd.devicepolice', '=', 's.id')
                    ->join('users as u', 'd.uid', '=', 'u.id')
                    ->where('d.username', 'like', '%' . $imitationdata . '%')
                    ->select('d.*', 't.tname', 'g.gas', 'w.danwei', 's.status_name', 'u.username as nameh', 'u.isadmin')
                    ->get();
            } else {
                $data = DB::table('device as d')
                    ->join('device_type as t', 'd.dtype', '=', 't.tid')
                    ->join('gas as g', 'd.status', '=', 'g.id')
                    ->join('danwei as  w', 'd.devicemonad', '=', 'w.id')
                    ->join('status as s', 'd.devicepolice', '=', 's.id')
                    ->join('users as u', 'd.uid', '=', 'u.id')
                    ->where('d.devicenum', 'like', '%' . $imitationdata . '%')
                    ->select('d.*', 't.tname', 'g.gas', 'w.danwei', 's.status_name', 'u.username as nameh', 'u.isadmin')
                    ->get();
            }
            return $this->jsonSuccessData($data);
        } else {
            return $this->jsonSuccessData('');
        }

    }

    //指定查询
    public function setseachdata(Request $request)
    {
        $setdata = $request->input('setseachdata');
        if ($this->isKanji($setdata)) {
            $data = DB::table('device as d')
                ->join('device_type as t', 'd.dtype', '=', 't.tid')
                ->join('gas as g', 'd.status', '=', 'g.id')
                ->join('danwei as  w', 'd.devicemonad', '=', 'w.id')
                ->join('status as s', 'd.devicepolice', '=', 's.id')
                ->join('users as u', 'd.uid', '=', 'u.id')
                ->where('d.username', '=', $setdata)
                ->select('d.*', 't.tname', 'g.gas', 'w.danwei', 's.status_name', 'u.username as nameh', 'u.isadmin')
                ->get();
        } else {
            $data = DB::table('device as d')
                ->join('device_type as t', 'd.dtype', '=', 't.tid')
                ->join('gas as g', 'd.status', '=', 'g.id')
                ->join('danwei as  w', 'd.devicemonad', '=', 'w.id')
                ->join('status as s', 'd.devicepolice', '=', 's.id')
                ->join('users as u', 'd.uid', '=', 'u.id')
                ->where('d.devicenum', '=', $setdata)
                ->select('d.*', 't.tname', 'g.gas', 'w.danwei', 's.status_name', 'u.username as nameh', 'u.isadmin')
                ->get();
        }
        return $this->jsonSuccessData($data);
    }

    //返回设备类型和单位和介质
    public function devicetype()
    {
        $gas = DB::table('gas')->get()->toArray();
        $danwei = DB::table('danwei')->get()->toArray();
        $devicetypecount = DB::table('device_type as t')
            ->leftjoin('device as d', 'd.dtype', '=', 't.tid')
            ->selectRaw('t.*,count(d.id) as counnum')
            ->groupBy('t.tid')
            ->get()->toArray();
        return $this->jsonSuccessData(['devicetype' => $devicetypecount, 'gas' => $gas, 'danwei' => $danwei]);
    }

    public function isemail(Request $request)
    {
        $isemail = $request->input('email');
        $data = DB::table('users')->where('email','=',$isemail)->first();
        if($data){
            return $this->jsonSuccessData(1);
        }else{
            return $this->jsonSuccessData(2);
        }
    }

    //监测是否是汉子
    private function isKanji($str)
    {
        if (preg_match("/^[\x7f-\xff]+$/", $str)) {
            return true;
        } else {
            return false;
        }
    }

    //主页home的
}